'==============================================================================
'	Dreidimensionales Vektorfeld (-y, x, z), vgl. Wikipedia "Vektorfeld"
'	Vektorfeld.bas
'==============================================================================

#INCLUDE "Inc\3D-GRAPH.BAS"

DIM AS  DOUBLE r, phi, dr, dphi, dz, x0, y0, z0, x1, y1, z1, gamma = -20, angp = 30, _
  xp0, zp0, xp1, zp1
 							
SCREEN 0
COLOR 0, 15
CLS

PRINT "         Vektorfeld v = (-y, x, z), vgl. Wikipedia 'Vektorfeld'"
PRINT
PRINT "Ein Vektor (x, y) mit radialer Richtung wird durch eine Rotation um 90 Grad"
PRINT "um die z-Achse in einen Vektor (-y, x) mit tangentialer Richtung"
PRINT "ueberfuhrt. Ein Vektorfeld v = (-y, x, z) beschreibt also anschaulich eine"
PRINT "Stroemung um die z-Achse, die ausserdem noch in positive und negative"
PRINT "z-Richtung auseinanderfliesst."
PRINT
PRINT "Die Divergenz ist:"
PRINT "  div v = dvx/dx + dvy/dy + dvz/dz = 1"
PRINT "Hier liefert nur die z-Komponente vz einen Beitrag!"
PRINT
PRINT "Die Rotation ist:"
PRINT "  rot v = (dvz/dy - dvy/dz, dvx/dz - dvz / dx, dvy/ dx - dvx/dy) = (0, 0, 2)"
PRINT "Sie entspricht der doppelten Winkelgeschwindigkeit und weist in z-Richtung."

WINDOWTITLE "Vektorfeld (-y, x, z)"
SCREEN 18
WINDOW(-15, -16) - (15, 14)
COLOR 0, 15
CLS

dr = 2
dphi = 2 * pi / 24
dz = 3

Koordinaten3D(-6, 6, -6, 6, -6, 6, gamma, angp, "x", "y", "z")

'(x0, y0, z0) sind die Anfangspunkte der Vektoren, 
'(x1, y1, z1) sind die Endpunkte der Vektoren
'Vektorlaenge auf ein Fuenftel verkleinert
FOR r = 2 TO 6 STEP dr
	FOR phi = 0 TO 2 * pi STEP dphi
		FOR z0 = -6 TO 6 STEP dz
			x0 = r * COS(phi)
			y0 = r * SIN(phi)
			x1 = x0 - y0 / 5
			y1 = y0 + x0 / 5
			z1 = z0 + z0 / 5
			Abb3D(x0, y0, z0, gamma, angp, xp0, zp0)
			Abb3D(x1, y1, z1, gamma, angp, xp1, zp1)     
			CIRCLE(xp0, zp0), 0.1, 1
			LINE(xp0, zp0) - (xp1, zp1), 1
		NEXT z0
	NEXT phi
NEXT r

GETKEY

