'=========================================================================
' Waermeleitungsgleichung
' WAERME.BAS
'=========================================================================

#INCLUDE "Inc\3D-Graph.bas"

DECLARE FUNCTION Temp(t AS DOUBLE, x AS DOUBLE) AS DOUBLE

DIM SHARED AS DOUBLE xmax, a, b
DIM AS STRING*1 jn

Anfang:
SCREEN 0
COLOR 7, 1
CLS
PRINT "Loesung der Waermeleitungsgleichung fuer sinusfoermige Randbedingung"
PRINT
PRINT "Vgl. Vogel: Probleme aus der Physik, Aufgabe 5.4.5"
PRINT
PRINT "Auf der Aussenflaeche einer Wand folgt die Temperatur im Tagesverlauf"
PRINT "naeherungsweise der Funktion"
PRINT "T = T0 + T1 * sin(omega * t)"
PRINT "Die Loesung der Waermeleitungsgleichung liefert dann im Inneren der Wand"
PRINT "den Temperaturverlauf"
PRINT "T = T0 + T1 * exp(-a * x) * sin(omega * t - a * x),"
PRINT "wobei a eine Konstante ist,"
PRINT "d.h. die Temperatur im Wandinnern folgt der Aussentemperatur verzoegert"
PRINT "und mit gedaempfter Amplitude."
PRINT
INPUT "a im Verhaeltnis zur Wanddicke: ", a

xmax = 5
b = a / xmax

WINDOWTITLE "Temperaturverteilung T(x, t) fuer a = " + STR(a) + ", T0 = 0 gesetzt" 
SCREEN 18, 32
COLOR RGB0, RGB15
CLS 0

WINDOW(-1, -2.5) - (8, 3)
Koordinaten3D(0, 2 * pi, 0, 5, -1, 1, -20, 20, "t", "x", "T")
PlotFktxy(@Temp, 0, 2 * pi, 0, 5, -20, 20)
LOCATE 29, 30
INPUT "Nochmal j/n: ", jn
IF UCASE(jn) = "J" THEN GOTO Anfang




FUNCTION Temp(t AS DOUBLE, x AS DOUBLE) AS DOUBLE
  Temp = EXP(-b * x) * SIN(t - b * x)
END FUNCTION
  